package com.emoon.knowledge.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.knowledge.domain.ThinkProject;
import com.emoon.knowledge.domain.bo.ThinkProjectBo;
import com.emoon.knowledge.domain.vo.ThinkProjectVo;
import com.emoon.knowledge.mapper.ThinkProjectMapper;
import com.emoon.knowledge.service.IThinkProjectService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 项目Service业务层处理
 *
 * @author wangkang
 * @date 2025-11-26
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ThinkProjectServiceImpl implements IThinkProjectService {

    private final ThinkProjectMapper baseMapper;

    /**
     * 查询项目
     *
     * @param id 主键
     * @return 项目
     */
    @Override
    public ThinkProjectVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询项目列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 项目分页列表
     */
    @Override
    public TableDataInfo<ThinkProjectVo> queryPageList(ThinkProjectBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ThinkProject> lqw = buildQueryWrapper(bo);
        Page<ThinkProjectVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的项目列表
     *
     * @param bo 查询条件
     * @return 项目列表
     */
    @Override
    public List<ThinkProjectVo> queryList(ThinkProjectBo bo) {
        LambdaQueryWrapper<ThinkProject> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ThinkProject> buildQueryWrapper(ThinkProjectBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ThinkProject> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ThinkProject::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getOrganization()), ThinkProject::getOrganization, bo.getOrganization());
        lqw.eq(StringUtils.isNotBlank(bo.getProject()), ThinkProject::getProject, bo.getProject());
        lqw.eq(StringUtils.isNotBlank(bo.getPrivateKey()), ThinkProject::getPrivateKey, bo.getPrivateKey());
        lqw.eq(StringUtils.isNotBlank(bo.getPublicKey()), ThinkProject::getPublicKey, bo.getPublicKey());
        lqw.eq(StringUtils.isNotBlank(bo.getModels()), ThinkProject::getModels, bo.getModels());
        lqw.eq(StringUtils.isNotBlank(bo.getRags()), ThinkProject::getRags, bo.getRags());
        lqw.eq(StringUtils.isNotBlank(bo.getAgents()), ThinkProject::getAgents, bo.getAgents());
        return lqw;
    }

    /**
     * 新增项目
     *
     * @param bo 项目
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ThinkProjectBo bo) {
        ThinkProject add = MapstructUtils.convert(bo, ThinkProject.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改项目
     *
     * @param bo 项目
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ThinkProjectBo bo) {
        ThinkProject update = MapstructUtils.convert(bo, ThinkProject.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ThinkProject entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除项目信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
